# Three js

Maintenant que vous avez vu la version bas niveau de webgl, nous allons utiliser three.js, qui est une bibliothèque de plus haut niveau pour créer des mondes 3D en webgl.

## Pré-requis

Il faut une installation de [npm](https://www.npmjs.com/) (node.js package manager) 
Le plus simple c'est d'utilires [nvm](https://github.com/nvm-sh/nvm) (node version manager) 

Pour installer en local sous linux
```{.sh}
curl -o- https://raw.githubusercontent.com/nvm-sh/nvm/v0.39.3/install.sh | bash
```

Pour toutes autres versions et problèmes d'installation voir la doc sur la page de nvm

## Doc rapide des fichiers fournis

- `package.json` : fichier de configuration npm, defini les packages a installer, et la commande `npm run start`
- `webpack.config.js` : fichier de configuration webpack, defini comment vos sources sont packé pour faire une application, et permet aussi de lancer un serveur en local.
- `src/index.html` : votre page www, minimaliste, avec uniqument le canvas identifié par "c", qui prend toute la page. 
- `src/index.js` : votre application
- `npm install` : install les packets
- `npm run start` : lance un serveur local pour afficher votre applications. Les changements sur les fichiers sources recharge automatiquement la page.

## Travail à faire

Vous devez vous aidez de la documentation et des exemples de three.js. Vous pouvez vous servir d'autre ressources **merci de les indiquer dans vos codes sources**

### Ajouter des lumières

Sans effet immédiat car il faut un objet avec un matériau qui réagit à la lumière, vous pourrez ajuster les paramètres des lumières une fois ces matériaux opérationel

[THREE.PointLight](https://threejs.org/docs/?q=light#api/en/lights/PointLight)

### Modifier matériau

BasicMaterial vers StandardMaterial

[THREE.MeshStandardMaterial](https://threejs.org/docs/?q=material#api/en/materials/MeshStandardMaterial)

### Ajouter d'autres objets

Parmi les objets standards de three.js vous devez construire une scene

[THREE.Geometry](https://threejs.org/docs/?q=Geometry#api/en/geometries/TorusKnotGeometry)

### Animer les objets, via les transformations des objets par ex

Les transformations sont à mettre à jour dans la fonction render, en fonction du temps.

### Générer un ensemble d'objets

Les objets peuvent être "attachés" à un autre objet, le mieux est via des groupes [THREE.Group](https://threejs.org/docs/?q=object3d#api/en/objects/Group)

ou directement en ajoutant un objet à un autre [THREE.Object3D.add()](https://threejs.org/docs/?q=object3d#api/en/core/Object3D.add)

Vous devez ajouter des objets avec des positions relatives (un objet décaler par rapport à un autre, en récursif)

### Ajout texture

[THREE.Textures](https://threejs.org/docs/#api/en/constants/Textures)
[THREE.Texture](https://threejs.org/docs/#api/en/textures/Texture)

Ajouter des textures à vos matériaux, pour moduler les différents paramètres.

Voici quelques sites pour récupérer des textures (liste non exhaustive et non garantie, nous attendons vos retour pour affiner la liste !)

- [https://ambientcg.com/](https://ambientcg.com/)
- [https://freepbr.com/](https://freepbr.com/)
- [https://www.sharetextures.com/assets](https://www.sharetextures.com/assets)
- [https://www.cgbookcase.com/](https://www.cgbookcase.com/)
- [https://www.poliigon.com/search?credit=0](https://www.poliigon.com/search?credit=0)
- [https://www.archinspirations.com/materials](https://www.archinspirations.com/materials)
- [https://artisticrender.com/](https://artisticrender.com/top-32-free-texture-libraries-for-blender-and-3d-artists/)
- [https://www.turbosquid.com/Search/Textures](https://www.turbosquid.com/Search/Textures)
- [https://polyhaven.com/](https://polyhaven.com/)
- [https://renderman.pixar.com/pixar-one-twenty-eight](https://renderman.pixar.com/pixar-one-twenty-eight)
- [https://www.3dxo.com/textures](https://www.3dxo.com/textures)
- [http://texturer.com/](http://texturer.com/)
- [https://store.3dtotal.com/](https://store.3dtotal.com/products/total-textures-19-pack-download-bundle-50-off-download-only)
- [https://www.textures.com/](https://www.textures.com/)
- [https://www.arroway-textures.ch/](https://www.arroway-textures.ch/)
- [https://www.poliigon.com/textures/free](https://www.poliigon.com/textures/free)
